// calculate Temperature for NTCLE413 Temperature Sensors

#include <stdio.h>
#include <stdint.h>
#include <math.h>

#define R0 10000     //Ohm
#define BETA 3435    //Kelvin
#define T0 298.15    //Kelvin

float calcTemp(int16_t vref2, int16_t adcVoltage){
    float r_ntc = R0/((vref2/adcVoltage)-1);

    float temp = r_ntc / R0;        // (R/Ro)
    temp = logf(temp);               // ln(R/Ro)
    temp /= BETA;                   // 1/B * ln(R/Ro)
    temp += 1.0 / (T0 + 273.15);    // + (1/To)
    temp = 1.0 / temp;              // Invert
    temp -= 273.15;                 // convert to °C
    
    return temp;
}